Index: squid/src/store_swapout.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_swapout.c,v
retrieving revision 1.1.1.3.4.1.4.1
retrieving revision 1.1.1.3.4.1.4.2
diff -u -r1.1.1.3.4.1.4.1 -r1.1.1.3.4.1.4.2
--- squid/src/store_swapout.c	16 Apr 2000 23:59:17 -0000	1.1.1.3.4.1.4.1
+++ squid/src/store_swapout.c	3 May 2000 19:22:28 -0000	1.1.1.3.4.1.4.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_swapout.c,v 1.1.1.3.4.1.4.1 2000/04/16 23:59:17 hno Exp $
+ * $Id: store_swapout.c,v 1.1.1.3.4.1.4.2 2000/05/03 19:22:28 hno Exp $
  *
  * DEBUG: section 20    Storage Manager Swapout Functions
  * AUTHOR: Duane Wessels
@@ -38,6 +38,7 @@
 static off_t storeSwapOutObjectBytesOnDisk(const MemObject *);
 static void storeSwapOutStart(StoreEntry * e);
 static STIOCB storeSwapOutFileClosed;
+static STIOCB storeSwapOutFileNotify;
 
 /* start swapping object to disk */
 static void
@@ -49,31 +50,51 @@
     tlv *tlv_list;
     char *buf;
     assert(mem);
-    storeLockObject(e);
-    storeSwapFileNumberSet(e, storeDirMapAllocate());
+    /* Build the swap metadata, so the filesystem will know how much
+     * metadata there is to store
+     */
+    debug(20, 5) ("storeSwapOutStart: Begin SwapOut '%s' to dirno %d, fileno %08X\n",
+	storeUrl(e), e->swap_dirn, e->swap_filen);
+    e->swap_status = SWAPOUT_WRITING;
+    tlv_list = storeSwapMetaBuild(e);
+    buf = storeSwapMetaPack(tlv_list, &swap_hdr_sz);
+    storeSwapTLVFree(tlv_list);
+    mem->swap_hdr_sz = (size_t) swap_hdr_sz;
+    /* Create the swap file */
     c = xcalloc(1, sizeof(*c));
     c->data = e;
     cbdataAdd(c, cbdataXfree, 0);
-    mem->swapout.sio = storeOpen(e->swap_file_number,
-	O_WRONLY, storeSwapOutFileClosed, c);
+    mem->swapout.sio = storeCreate(e, storeSwapOutFileNotify, storeSwapOutFileClosed, c);
     if (NULL == mem->swapout.sio) {
 	e->swap_status = SWAPOUT_NONE;
-	storeSwapFileNumberSet(e, -1);
 	cbdataFree(c);
-	storeUnlockObject(e);
+	xfree(buf);
 	return;
     }
-    e->swap_status = SWAPOUT_WRITING;
+    storeLockObject(e); /* Don't lock until after create, or the replacement
+                         * code might get confused */
+    /* Pick up the file number if it was assigned immediately */
+    e->swap_filen = mem->swapout.sio->swap_filen;
+    e->swap_dirn = mem->swapout.sio->swap_dirn;
+    /* write out the swap metadata */
     cbdataLock(mem->swapout.sio);
-    debug(20, 5) ("storeSwapOutStart: Begin SwapOut '%s' to fileno %08X\n",
-	storeUrl(e), e->swap_file_number);
-    tlv_list = storeSwapMetaBuild(e);
-    buf = storeSwapMetaPack(tlv_list, &swap_hdr_sz);
-    storeSwapTLVFree(tlv_list);
-    mem->swap_hdr_sz = (size_t) swap_hdr_sz;
     storeWrite(mem->swapout.sio, buf, mem->swap_hdr_sz, 0, xfree);
 }
 
+static void
+storeSwapOutFileNotify(void *data, int errflag, storeIOState * sio)
+{
+    generic_cbdata *c = data;
+    StoreEntry *e = c->data;
+    MemObject *mem = e->mem_obj;
+    assert(e->swap_status == SWAPOUT_WRITING);
+    assert(mem);
+    assert(mem->swapout.sio == sio);
+    assert(errflag == 0);
+    e->swap_filen = mem->swapout.sio->swap_filen;
+    e->swap_dirn = mem->swapout.sio->swap_dirn;
+}
+
 void
 storeSwapOut(StoreEntry * e)
 {
@@ -82,7 +103,6 @@
     off_t new_mem_lo;
     off_t on_disk = 0;
     size_t swapout_size;
-    char *swap_buf;
     ssize_t swap_buf_len;
     if (mem == NULL)
 	return;
@@ -108,10 +128,25 @@
     lowest_offset = storeLowestMemReaderOffset(e);
     debug(20, 7) ("storeSwapOut: lowest_offset = %d\n",
 	(int) lowest_offset);
-    if (mem->inmem_hi - lowest_offset > DISK_PAGE_SIZE)
-        new_mem_lo = lowest_offset;
+    /*
+     * Grab the swapout_size and check to see whether we're going to defer
+     * the swapout based upon size
+     */
+    swapout_size = (size_t) (mem->inmem_hi - mem->swapout.queue_offset);
+    if ((e->store_status != STORE_OK) && (swapout_size < store_maxobjsize)) {
+        debug (20, 5) ("storeSwapOut: Deferring starting swapping out\n"); 
+        return;
+    }
+    /*
+     * Careful.  lowest_offset can be greater than inmem_hi, such
+     * as in the case of a range request.
+     */
+    if (mem->inmem_hi < lowest_offset)
+	new_mem_lo = lowest_offset;
+    else if (mem->inmem_hi - lowest_offset > SM_PAGE_SIZE)
+	new_mem_lo = lowest_offset;
     else
-        new_mem_lo = mem->inmem_lo;
+	new_mem_lo = mem->inmem_lo;
     assert(new_mem_lo >= mem->inmem_lo);
     if (storeSwapOutAble(e)) {
 	/*
@@ -136,7 +171,6 @@
 	assert(mem->inmem_lo <= on_disk);
     if (!storeSwapOutAble(e))
 	return;
-    swapout_size = (size_t) (mem->inmem_hi - mem->swapout.queue_offset);
     debug(20, 7) ("storeSwapOut: swapout_size = %d\n",
 	(int) swapout_size);
     if (swapout_size == 0) {
@@ -146,7 +180,7 @@
     }
     if (e->store_status == STORE_PENDING) {
 	/* wait for a full block to write */
-	if (swapout_size < DISK_PAGE_SIZE)
+	if (swapout_size < SM_PAGE_SIZE)
 	    return;
 	/*
 	 * Wait until we are below the disk FD limit, only if the
@@ -155,6 +189,14 @@
 	if (storeTooManyDiskFilesOpen() && !fwdCheckDeferRead(-1, e))
 	    return;
     }
+    /*
+     * Don't start swapping out until its either all in memory, or bigger
+     * than the maximum object size (so we pick a -1 maxobjsize fs)
+     */
+    if ((e->store_status != STORE_OK) && (swapout_size < store_maxobjsize)) {
+        debug (20, 5) ("storeSwapOut: Deferring starting swapping out\n"); 
+        return;
+    }
     /* Ok, we have stuff to swap out.  Is there a swapout.sio open? */
     if (e->swap_status == SWAPOUT_NONE) {
 	assert(mem->swapout.sio == NULL);
@@ -168,35 +210,42 @@
     if (NULL == mem->swapout.sio)
 	return;
     do {
-	if (swapout_size > DISK_PAGE_SIZE)
-	    swapout_size = DISK_PAGE_SIZE;
-	swap_buf = memAllocate(MEM_DISK_BUF);
-	swap_buf_len = stmemCopy(&mem->data_hdr,
-	    mem->swapout.queue_offset,
-	    swap_buf,
-	    swapout_size);
-	if (swap_buf_len < 0) {
-	    debug(20, 1) ("stmemCopy returned %d for '%s'\n", swap_buf_len, storeKeyText(e->key));
-	    storeUnlink(e->swap_file_number);
-	    storeSwapFileNumberSet(e, -1);
-	    e->swap_status = SWAPOUT_NONE;
-	    memFree(swap_buf, MEM_DISK_BUF);
-	    storeReleaseRequest(e);
-	    storeSwapOutFileClose(e);
-	    return;
+        /*
+	 * Evil hack time.
+	 * We are paging out to disk in page size chunks. however, later on when
+	 * we update the queue position, we might not have a page (I *think*),
+	 * so we do the actual page update here.
+         */
+
+        if (mem->swapout.memnode == NULL) {
+            /* We need to swap out the first page */
+	    mem->swapout.memnode = mem->data_hdr.head;
+	} else {
+            /* We need to swap out the next page */
+	    mem->swapout.memnode = mem->swapout.memnode->next;
 	}
+	/*
+	 * Get the length of this buffer. We are assuming(!) that the buffer
+	 * length won't change on this buffer, or things are going to be very
+	 * strange. I think that after the copy to a buffer is done, the buffer
+	 * size should stay fixed regardless so that this code isn't confused,
+	 * but we can look at this at a later date or whenever the code results
+	 * in bad swapouts, whichever happens first. :-)
+	 */
+	swap_buf_len = mem->swapout.memnode->len;
+
 	debug(20, 3) ("storeSwapOut: swap_buf_len = %d\n", (int) swap_buf_len);
 	assert(swap_buf_len > 0);
 	debug(20, 3) ("storeSwapOut: swapping out %d bytes from %d\n",
 	    swap_buf_len, (int) mem->swapout.queue_offset);
 	mem->swapout.queue_offset += swap_buf_len;
-	storeWrite(mem->swapout.sio, swap_buf, swap_buf_len, -1, memFreeDISK);
+	storeWrite(mem->swapout.sio, mem->swapout.memnode->data, swap_buf_len, -1, NULL);
 	/* the storeWrite() call might generate an error */
 	if (e->swap_status != SWAPOUT_WRITING)
 	    break;
 	swapout_size = (size_t) (mem->inmem_hi - mem->swapout.queue_offset);
 	if (e->store_status == STORE_PENDING)
-	    if (swapout_size < DISK_PAGE_SIZE)
+	    if (swapout_size < SM_PAGE_SIZE)
 		break;
     } while (swapout_size > 0);
     if (NULL == mem->swapout.sio)
@@ -234,30 +283,26 @@
     assert(e->swap_status == SWAPOUT_WRITING);
     cbdataFree(c);
     if (errflag) {
-	sfileno bad = e->swap_file_number;
-	debug(20, 1) ("storeSwapOutFileClosed: swapfile %08X, errflag=%d\n\t%s\n",
-	    bad, errflag, xstrerror());
-	storeSwapFileNumberSet(e, -1);
-	/*
-	 * yuck.  re-set the filemap bit for some errors so that
-	 * we don't try re-using it over and over
-	 */
-	if (errno == EPERM)
-	    storeDirMapBitSet(bad);
+	debug(20, 1) ("storeSwapOutFileClosed: dirno %d, swapfile %08X, errflag=%d\n\t%s\n",
+	    e->swap_dirn, e->swap_filen, errflag, xstrerror());
 	if (errflag == DISK_NO_SPACE_LEFT) {
-	    storeDirDiskFull(bad);
+	    storeDirDiskFull(e->swap_dirn);
 	    storeDirConfigure();
 	    storeConfigure();
 	}
-	storeReleaseRequest(e);
+	if (e->swap_filen > 0)
+	    storeUnlink(e);
+        e->swap_filen = -1;
+        e->swap_dirn = -1;
 	e->swap_status = SWAPOUT_NONE;
+	storeReleaseRequest(e);
     } else {
 	/* swapping complete */
-	debug(20, 3) ("storeSwapOutFileClosed: SwapOut complete: '%s' to %08X\n",
-	    storeUrl(e), e->swap_file_number);
+	debug(20, 3) ("storeSwapOutFileClosed: SwapOut complete: '%s' to %d, %08X\n",
+	    storeUrl(e), e->swap_dirn, e->swap_filen);
 	e->swap_file_sz = objectLen(e) + mem->swap_hdr_sz;
 	e->swap_status = SWAPOUT_DONE;
-	storeDirUpdateSwapSize(e->swap_file_number, e->swap_file_sz, 1);
+	storeDirUpdateSwapSize(&Config.cacheSwap.swapDirs[e->swap_dirn], e->swap_file_sz, 1);
 	if (storeCheckCachable(e)) {
 	    storeLog(STORE_LOG_SWAPOUT, e);
 	    storeDirSwapLog(e, SWAP_LOG_ADD);
Index: squid/src/structs.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/structs.h,v
retrieving revision 1.1.1.3.4.1.4.2
retrieving revision 1.1.1.3.4.1.4.3
diff -u -r1.1.1.3.4.1.4.2 -r1.1.1.3.4.1.4.3
--- squid/src/structs.h	16 Apr 2000 23:59:17 -0000	1.1.1.3.4.1.4.2
+++ squid/src/structs.h	3 May 2000 19:22:28 -0000	1.1.1.3.4.1.4.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: structs.h,v 1.1.1.3.4.1.4.2 2000/04/16 23:59:17 hno Exp $
+ * $Id: structs.h,v 1.1.1.3.4.1.4.3 2000/05/03 19:22:28 hno Exp $
  *
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -49,12 +49,6 @@
     acl_ip_data *next;		/* used for parsing, not for storing */
 };
 
-struct _acl_snmp_comm {
-    char *name;
-    void *community;
-    acl_snmp_comm *next;
-};
-
 struct _acl_time_data {
     int weekbits;
     int start;
@@ -159,11 +153,6 @@
     void *callback_data;
 };
 
-struct _aio_result_t {
-    int aio_return;
-    int aio_errno;
-};
-
 struct _wordlist {
     char *key;
     wordlist *next;
@@ -266,6 +255,10 @@
 #if USE_IDENT
 	time_t ident;
 #endif
+#if !USE_DNSSERVERS
+	time_t idns_retransmit;
+	time_t idns_query;
+#endif
     } Timeout;
     size_t maxRequestHeaderSize;
     size_t maxRequestBodySize;
@@ -301,29 +294,34 @@
 	char *access;
 	char *store;
 	char *swap;
+#if USE_USERAGENT_LOG
 	char *useragent;
+#endif
 	int rotateNumber;
     } Log;
     char *adminEmail;
     char *effectiveUser;
     char *effectiveGroup;
     struct {
-#if USE_DNSSERVER
+#if USE_DNSSERVERS
 	char *dnsserver;
 #endif
 	wordlist *redirect;
 	wordlist *authenticate;
+#if USE_ICMP
 	char *pinger;
+#endif
 	char *unlinkd;
     } Program;
-#if USE_DNSSERVER
+#if USE_DNSSERVERS
     int dnsChildren;
 #endif
     int redirectChildren;
     int authenticateChildren;
-    int authenticateTTL;
-    int authenticateIpTTL;
+    time_t authenticateTTL;
+    time_t authenticateIpTTL;
     struct {
+	int single_host;
 	char *host;
 	u_short port;
     } Accel;
@@ -382,7 +380,7 @@
     } Netdb;
     struct {
 	int log_udp;
-#if USE_DNSSERVER
+#if USE_DNSSERVERS
 	int res_defnames;
 #endif
 	int anonymizer;
@@ -407,6 +405,7 @@
 	int offline;
 	int redir_rewrites_host;
 	int prefer_direct;
+	int nonhierarchical_direct;
 	int strip_query_terms;
 	int redirector_bypass;
 	int ignore_unknown_nameservers;
@@ -415,6 +414,8 @@
 #if USE_CACHE_DIGESTS
 	int digest_generation;
 #endif
+	int log_ip_on_direct;
+	int authenticateIpTTLStrict;
     } onoff;
     acl *aclList;
     struct {
@@ -771,6 +772,7 @@
     StoreEntry *entry;
     request_t *request;
     char *reply_hdr;
+    size_t reply_hdr_size;
     int reply_hdr_state;
     peer *peer;			/* peer request made to */
     int eof;			/* reached end-of-object? */
@@ -1066,8 +1068,11 @@
 	int ignored_replies;
 	int n_keepalives_sent;
 	int n_keepalives_recv;
+	time_t probe_start;
 	time_t last_query;
 	time_t last_reply;
+	time_t last_connect_failure;
+	time_t last_connect_probe;
 	int logged_state;	/* so we can print dead/revived msgs */
     } stats;
     struct {
@@ -1101,6 +1106,7 @@
 #if DELAY_POOLS
 	unsigned int no_delay:1;
 #endif
+	unsigned int allow_miss:1;
     } options;
     int weight;
     struct {
@@ -1119,10 +1125,10 @@
     char *digest_url;
 #endif
     int tcp_up;			/* 0 if a connect() fails */
-    time_t last_fail_time;
     struct in_addr addresses[10];
     int n_addresses;
     int rr_count;
+    int rr_lastcount;
     peer *next;
     int test_fd;
 #if USE_CARP
@@ -1144,7 +1150,7 @@
 };
 
 struct _net_db_peer {
-    char *peername;
+    const char *peername;
     double hops;
     double rtt;
     time_t expires;
@@ -1199,6 +1205,7 @@
     aclCheck_t *acl_checklist;
 };
 
+#if USE_ICMP
 struct _pingerEchoData {
     struct in_addr to;
     unsigned char opcode;
@@ -1214,6 +1221,7 @@
     int psize;
     char payload[PINGER_PAYLOAD_SZ];
 };
+#endif
 
 struct _icp_common_t {
     unsigned char opcode;	/* opcode */
@@ -1281,6 +1289,7 @@
     int nclients;
     struct {
 	off_t queue_offset;	/* relative to in-mem data */
+        mem_node *memnode;	/* which node we're currently paging out */
 	storeIOState *sio;
     } swapout;
     HttpReply *reply;
@@ -1322,12 +1331,14 @@
     size_t swap_file_sz;
     u_short refcount;
     u_short flags;
-    sfileno swap_file_number;
-#if HEAP_REPLACEMENT
-    heap_node *node;
-#else
-    dlink_node lru;
+    sdirno swap_dirn;
+    sfileno swap_filen;
+    union {
+#ifdef HEAP_REPLACEMENT
+        heap_node *node;
 #endif
+        dlink_node lru;
+    } repl;
     u_short lock_count;		/* Assume < 65536! */
     mem_status_t mem_status:3;
     ping_status_t ping_status:3;
@@ -1336,23 +1347,46 @@
 };
 
 struct _SwapDir {
-    swapdir_t type;
-    fileMap *map;
+    char *type;
     int cur_size;
     int low_size;
     int max_size;
     char *path;
     int index;			/* This entry's index into the swapDirs array */
-    sfileno suggest;
+    int suggest;
+    size_t max_objsize;
+    union {
+#ifdef HEAP_REPLACEMENT
+        struct {
+	   heap *heap;
+	} heap;
+#endif
+        struct {
+	   dlink_list list;
+	   dlink_node *walker;
+	} lru;
+    } repl;
     int removals;
     int scanned;
     struct {
 	unsigned int selected:1;
 	unsigned int read_only:1;
     } flags;
-    STINIT *init;
-    STNEWFS *newfs;
+    STINIT *init;		/* Initialise the fs */
+    STNEWFS *newfs;		/* Create a new fs */
+    STDUMP *dump;		/* Dump fs config snippet */
+    STFREE *freefs;		/* Free the fs data */
+    STDBLCHECK *dblcheck;	/* Double check the obj integrity */
+    STSTATFS *statfs;		/* Dump fs statistics */
+    STMAINTAINFS *maintainfs;	/* Replacement maintainence */
+    STCHECKOBJ *checkobj;	/* Check if the fs will store an object */
+    /* These two are notifications */
+    STREFOBJ *refobj;		/* Reference this object */
+    STUNREFOBJ *unrefobj;	/* Unreference this object */
+    STCALLBACK *callback;	/* Handle pending callbacks */
+    STSYNC *sync;		/* Sync the directory */
     struct {
+        STOBJCREATE *create;
 	STOBJOPEN *open;
 	STOBJCLOSE *close;
 	STOBJREAD *read;
@@ -1369,33 +1403,7 @@
 	    void *state;
 	} clean;
     } log;
-#if !HEAP_REPLACEMENT
-    dlink_list lru_list;
-    dlink_node *lru_walker;
-#endif
-    union {
-	struct {
-	    int l1;
-	    int l2;
-	    int swaplog_fd;
-	} ufs;
-#if USE_DISKD
-	struct {
-	    int l1;
-	    int l2;
-	    int swaplog_fd;
-	    int smsgid;
-	    int rmsgid;
-	    int wfd;
-	    int away;
-	    struct {
-		char *buf;
-		link_list *stack;
-		int id;
-	    } shm;
-	} diskd;
-#endif
-    } u;
+    void *fsdata;
 };
 
 struct _request_flags {
@@ -1425,10 +1433,13 @@
 };
 
 struct _storeIOState {
-    sfileno swap_file_number;
+    sdirno swap_dirn;
+    sfileno swap_filen;
+    StoreEntry *e;		/* Need this so the FS layers can play god */
     mode_t mode;
     size_t st_size;		/* do stat(2) after read open */
-    off_t offset;		/* current offset pointer */
+    off_t offset;		/* current on-disk offset pointer */
+    STFNCB *file_callback;	/* called on delayed sfileno assignments */
     STIOCB *callback;
     void *callback_data;
     struct {
@@ -1438,38 +1449,7 @@
     struct {
 	unsigned int closing:1;	/* debugging aid */
     } flags;
-    union {
-	struct {
-	    int fd;
-	    struct {
-		unsigned int close_request:1;
-		unsigned int reading:1;
-		unsigned int writing:1;
-	    } flags;
-	} ufs;
-	struct {
-	    int fd;
-	    struct {
-		unsigned int close_request:1;
-		unsigned int reading:1;
-		unsigned int writing:1;
-		unsigned int opening:1;
-	    } flags;
-	    const char *read_buf;
-	    link_list *pending_writes;
-	    link_list *pending_reads;
-	} aufs;
-#if USE_DISKD
-	struct {
-	    int id;
-	    struct {
-		unsigned int reading:1;
-		unsigned int writing:1;
-	    } flags;
-	    char *read_buf;
-	} diskd;
-#endif
-    } type;
+    void *fsstate;
 };
 
 struct _request_t {
@@ -1711,9 +1691,13 @@
     tlv *next;
 };
 
+/*
+ * Do we need to have the dirn in here? I don't think so, since we already
+ * know the dirn .. 
+ */
 struct _storeSwapLogData {
     char op;
-    sfileno swap_file_number;
+    sfileno swap_filen;
     time_t timestamp;
     time_t lastref;
     time_t expires;
@@ -1893,6 +1877,35 @@
 				/* 6 - looking for double CRLF */
 } chunked_t;
 
+/*
+ * This defines an fs type
+ */
+
+struct _storefs_entry {
+    char *typestr;
+    STFSPARSE *parsefunc;
+    STFSRECONFIGURE *reconfigurefunc;
+    STFSSHUTDOWN *donefunc;
+};
+
+/*
+ * Async disk IO - this defines a async disk io queue
+ */
+
+struct _diskd_queue {
+    int smsgid;			/* send sysvmsg id */
+    int rmsgid;			/* recv sysvmsg id */
+    int wfd;			/* queue file descriptor ? */
+    int away;			/* number of requests away */
+    int sent_count;		/* number of messages sent */
+    int recv_count;		/* number of messages received */
+    struct {
+	char *buf;		/* shm buffer */
+	link_list *stack;	
+	int id;			/* sysvshm id */
+    } shm;
+};
+
 struct _Logfile {
     int fd;
     char path[MAXPATHLEN];
Index: squid/src/tools.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/tools.c,v
retrieving revision 1.1.1.3.8.1
retrieving revision 1.1.1.3.8.2
diff -u -r1.1.1.3.8.1 -r1.1.1.3.8.2
--- squid/src/tools.c	16 Apr 2000 23:59:17 -0000	1.1.1.3.8.1
+++ squid/src/tools.c	3 May 2000 19:22:28 -0000	1.1.1.3.8.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: tools.c,v 1.1.1.3.8.1 2000/04/16 23:59:17 hno Exp $
+ * $Id: tools.c,v 1.1.1.3.8.2 2000/05/03 19:22:28 hno Exp $
  *
  * DEBUG: section 21    Misc Functions
  * AUTHOR: Harvest Derived
@@ -848,7 +848,7 @@
 int
 stringHasWhitespace(const char *s)
 {
-    return (strcspn(s, w_space) != strlen(s));
+    return strpbrk(s, w_space) != NULL;
 }
 
 void
Index: squid/src/typedefs.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/typedefs.h,v
retrieving revision 1.1.1.3.8.1
retrieving revision 1.1.1.3.8.2
diff -u -r1.1.1.3.8.1 -r1.1.1.3.8.2
--- squid/src/typedefs.h	16 Apr 2000 23:59:17 -0000	1.1.1.3.8.1
+++ squid/src/typedefs.h	3 May 2000 19:22:28 -0000	1.1.1.3.8.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: typedefs.h,v 1.1.1.3.8.1 2000/04/16 23:59:17 hno Exp $
+ * $Id: typedefs.h,v 1.1.1.3.8.2 2000/05/03 19:22:28 hno Exp $
  *
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -39,6 +39,7 @@
 typedef unsigned int ping_status_t;
 typedef unsigned int swap_status_t;
 typedef int sfileno;
+typedef int sdirno;
 
 typedef struct {
     size_t bytes;
@@ -68,7 +69,6 @@
 typedef struct _acl_list acl_list;
 typedef struct _acl_access acl_access;
 typedef struct _aclCheck_t aclCheck_t;
-typedef struct _aio_result_t aio_result_t;
 typedef struct _wordlist wordlist;
 typedef struct _intlist intlist;
 typedef struct _intrange intrange;
@@ -168,6 +168,8 @@
 typedef struct _generic_cbdata generic_cbdata;
 typedef struct _storeIOState storeIOState;
 typedef struct _link_list link_list;
+typedef struct _storefs_entry storefs_entry_t;
+typedef struct _diskd_queue diskd_queue;
 typedef struct _Logfile Logfile;
 
 #if SQUID_SNMP
@@ -181,8 +183,6 @@
 typedef struct _delaySpec delaySpec;
 #endif
 
-/* define AIOCB even without USE_ASYNC_IO */
-typedef void AIOCB(int fd, void *, int aio_return, int aio_errno);
 typedef void CWCB(int fd, char *, size_t size, int flag, void *data);
 typedef void CNCB(int fd, int status, void *);
 
@@ -191,8 +191,16 @@
 typedef void FOCB(void *, int fd, int errcode);
 typedef void EVH(void *);
 typedef void PF(int, void *);
-typedef void DRCB(int fd, const char *buf, int size, int errflag, void *data);
-typedef void DWCB(int, int, size_t, void *);
+
+/* disk.c / diskd.c callback typedefs */
+typedef void DRCB(int, const char *buf, int size, int errflag, void *data);
+							/* Disk read CB */
+typedef void DWCB(int, int, size_t, void *);		/* disk write CB */
+typedef void DOCB(int, int errflag, void *data);	/* disk open CB */
+typedef void DCCB(int, int errflag, void *data);	/* disk close CB */
+typedef void DUCB(int errflag, void *data);		/* disk unlink CB */
+typedef void DTCB(int errflag, void *data);		/* disk trunc CB */
+
 typedef void FQDNH(const char *, void *);
 typedef void IDCB(const char *ident, void *data);
 typedef void IPH(const ipcache_addrs *, void *);
@@ -203,6 +211,7 @@
 typedef int DEFER(int fd, void *data);
 
 typedef void STIOCB(void *their_data, int errflag, storeIOState *);
+typedef void STFNCB(void *their_data, int errflag, storeIOState *);
 typedef void STRCB(void *their_data, const char *buf, ssize_t len);
 
 typedef void SIH(storeIOState *, void *);	/* swap in */
@@ -219,17 +228,39 @@
 
 typedef void STINIT(SwapDir *);
 typedef void STNEWFS(SwapDir *);
-typedef storeIOState *STOBJOPEN(sfileno, mode_t, STIOCB *, void *);
-typedef void STOBJCLOSE(storeIOState *);
-typedef void STOBJREAD(storeIOState *, char *, size_t, off_t, STRCB *, void *);
-typedef void STOBJWRITE(storeIOState *, char *, size_t, off_t, FREE *);
-typedef void STOBJUNLINK(sfileno);
+typedef void STDUMP(StoreEntry *, const char *, SwapDir *);
+typedef void STFREE(SwapDir *);
+typedef int STDBLCHECK(SwapDir *, StoreEntry *);
+typedef void STSTATFS(SwapDir *, StoreEntry *);
+typedef void STMAINTAINFS(SwapDir *);
+typedef int STCHECKOBJ(SwapDir *, const StoreEntry *);
+typedef void STREFOBJ(SwapDir *, StoreEntry *);
+typedef void STUNREFOBJ(SwapDir *, StoreEntry *);
+typedef void STSETUP(storefs_entry_t *);
+typedef void STDONE(void);
+typedef void STCALLBACK(SwapDir *);
+typedef void STSYNC(SwapDir *);
+
+typedef storeIOState *STOBJCREATE(SwapDir *, StoreEntry *, STFNCB *, STIOCB *, void *);
+typedef storeIOState *STOBJOPEN(SwapDir *, StoreEntry *, STFNCB *, STIOCB *, void *);
+typedef void STOBJCLOSE(SwapDir *, storeIOState *);
+typedef void STOBJREAD(SwapDir *, storeIOState *, char *, size_t, off_t, STRCB *, void *);
+typedef void STOBJWRITE(SwapDir *, storeIOState *, char *, size_t, off_t, FREE *);
+typedef void STOBJUNLINK(SwapDir *, StoreEntry *);
+
 typedef void STLOGOPEN(SwapDir *);
 typedef void STLOGCLOSE(SwapDir *);
 typedef void STLOGWRITE(const SwapDir *, const StoreEntry *, int);
 typedef int STLOGCLEANOPEN(SwapDir *);
 typedef void STLOGCLEANWRITE(const StoreEntry *, SwapDir *);
 
+/* Store dir configuration routines */
+/* SwapDir *sd, char *path ( + char *opt later when the strtok mess is gone) */
+typedef void STFSPARSE(SwapDir *, int, char *);
+typedef void STFSRECONFIGURE(SwapDir *, int, char *);
+typedef void STFSSTARTUP(void);
+typedef void STFSSHUTDOWN(void);
+
 typedef double hbase_f(double);
 typedef void StatHistBinDumper(StoreEntry *, int idx, double val, double size, int count);
 
Index: squid/src/unlinkd.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/unlinkd.c,v
retrieving revision 1.1.1.3.8.1
retrieving revision 1.1.1.3.8.2
diff -u -r1.1.1.3.8.1 -r1.1.1.3.8.2
--- squid/src/unlinkd.c	16 Apr 2000 23:59:17 -0000	1.1.1.3.8.1
+++ squid/src/unlinkd.c	3 May 2000 19:22:28 -0000	1.1.1.3.8.2
@@ -1,5 +1,5 @@
 /*
- * $Id: unlinkd.c,v 1.1.1.3.8.1 2000/04/16 23:59:17 hno Exp $
+ * $Id: unlinkd.c,v 1.1.1.3.8.2 2000/05/03 19:22:28 hno Exp $
  *
  * DEBUG: section 12    Unlink Daemon
  * AUTHOR: Duane Wessels
@@ -48,6 +48,8 @@
     int x;
     setbuf(stdin, NULL);
     setbuf(stdout, NULL);
+    close(2);
+    open("/dev/null", O_RDWR);
     while (fgets(buf, UNLINK_BUF_LEN, stdin)) {
 	if ((t = strchr(buf, '\n')))
 	    *t = '\0';
@@ -68,17 +70,14 @@
 
 /* This code gets linked to Squid */
 
-#if USE_UNLINKD
 static int unlinkd_wfd = -1;
 static int unlinkd_rfd = -1;
-#endif
 
 #define UNLINKD_QUEUE_LIMIT 20
 
 void
 unlinkdUnlink(const char *path)
 {
-#if USE_UNLINKD
     char buf[MAXPATHLEN];
     int l;
     int x;
@@ -141,13 +140,11 @@
     }
     Counter.unlink.requests++;
     queuelen++;
-#endif
 }
 
 void
 unlinkdClose(void)
 {
-#if USE_UNLINKD
     assert(unlinkd_wfd > -1);
     debug(12, 1) ("Closing unlinkd pipe on FD %d\n", unlinkd_wfd);
     file_close(unlinkd_wfd);
@@ -155,13 +152,11 @@
 	file_close(unlinkd_rfd);
     unlinkd_wfd = -1;
     unlinkd_rfd = -1;
-#endif
 }
 
 void
 unlinkdInit(void)
 {
-#if USE_UNLINKD
     int x;
     char *args[2];
     struct timeval slp;
@@ -198,9 +193,6 @@
     if (FD_PIPE == fd_table[unlinkd_wfd].type)
 	commUnsetNonBlocking(unlinkd_wfd);
     debug(12, 1) ("Unlinkd pipe opened on FD %d\n", unlinkd_wfd);
-#else
-    debug(12, 1) ("Unlinkd is disabled\n");
-#endif
 }
 
 #endif /* ndef UNLINK_DAEMON */
Index: squid/src/url.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/url.c,v
retrieving revision 1.1.1.3.8.1
retrieving revision 1.1.1.3.8.2
diff -u -r1.1.1.3.8.1 -r1.1.1.3.8.2
--- squid/src/url.c	16 Apr 2000 23:59:17 -0000	1.1.1.3.8.1
+++ squid/src/url.c	3 May 2000 19:22:28 -0000	1.1.1.3.8.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: url.c,v 1.1.1.3.8.1 2000/04/16 23:59:17 hno Exp $
+ * $Id: url.c,v 1.1.1.3.8.2 2000/05/03 19:22:28 hno Exp $
  *
  * DEBUG: section 23    URL Parsing
  * AUTHOR: Duane Wessels
@@ -127,7 +127,7 @@
      * way we expect it to.
      */
     assert(0 == matchDomainName("foo.com", "foo.com"));
-    assert(0 == matchDomainName(".foo.com", "foo.com"));
+    assert(0 < matchDomainName(".foo.com", "foo.com"));
     assert(0 == matchDomainName("foo.com", ".foo.com"));
     assert(0 == matchDomainName(".foo.com", ".foo.com"));
     assert(0 == matchDomainName("x.foo.com", ".foo.com"));
@@ -140,6 +140,8 @@
     assert(0 < matchDomainName("zzz.com", "foo.com"));
     assert(0 > matchDomainName("aaa.com", "foo.com"));
     assert(0 == matchDomainName("FOO.com", "foo.COM"));
+    assert(0 < matchDomainName("bfoo.com", "afoo.com"));
+    assert(0 > matchDomainName("afoo.com", "bfoo.com"));
     /* more cases? */
 }
 
@@ -241,10 +243,10 @@
 	port = urlDefaultPort(protocol);
 	/* Is there any login informaiton? */
 	if ((t = strrchr(host, '@'))) {
-	    strcpy(login, host);
+	    strcpy((char *)login, (char *)host);
 	    t = strrchr(login, '@');
 	    *t = 0;
-	    strcpy(host, t + 1);
+	    strcpy((char *)host, t + 1);
 	}
 	if ((t = strrchr(host, ':'))) {
 	    *t++ = '\0';
@@ -397,15 +399,12 @@
  *    HOST          DOMAIN        MATCH?
  * ------------- -------------    ------
  *    foo.com       foo.com         YES
- *   .foo.com       foo.com         YES
+ *   .foo.com       foo.com          NO
  *  x.foo.com       foo.com          NO
  *    foo.com      .foo.com         YES
  *   .foo.com      .foo.com         YES
  *  x.foo.com      .foo.com         YES
  *
- *  We strip leading dots on hosts (but not domains!) so that
- *  ".foo.com" is is always the same as "foo.com".
- *
  *  Return values:
  *     0 means the host matches the domain
  *     1 means the host is greater than the domain
@@ -417,8 +416,6 @@
 {
     int dl;
     int hl;
-    while ('.' == *h)
-	h++;
     hl = strlen(h);
     dl = strlen(d);
     /*
